package com.zhili.zkstationserver.component;

import com.alibaba.fastjson.JSON;
import com.zhili.zkstationserver.configuration.ServerConfig;
import com.zhili.zkstationserver.dto.StationControlEvent;
import com.zhili.zkstationserver.dto.StationMessage;
import com.zhili.zkstationserver.util.StationCenter;
import lombok.extern.slf4j.Slf4j;
import org.apache.curator.framework.CuratorFramework;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.Ordered;
import org.springframework.core.annotation.Order;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

@Component
@Slf4j
public class KafkaMessageHandler {

    @Autowired
    ServerConfig serverConfig;

    public KafkaMessageHandler(CuratorFramework client) {
    }

    @PostConstruct
    public void init(){
        log.info("KafkaMessageHandler PostConstruct:" + serverConfig);
    }

    @KafkaListener(topics = {"#{serverConfig.getInstanceId()}"}, groupId = "#{serverConfig.getServiceName()}")
    public void processExchangeEvent(ConsumerRecord<String, String> record, Acknowledgment ack){
        log.info("recv:"+record.value());
        StationControlEvent stationControlEvent = JSON.parseObject(record.value(), StationControlEvent.class);
        if(stationControlEvent.getType().equals("startExchange")){
            StationMessage stationMessage = new StationMessage();
            stationMessage.setCommand(504);
            stationMessage.setData(new byte[2]);
            StationCenter.sendToChannel(stationControlEvent.getStationConnInfo().getConnIdStr(),stationMessage);
        }
        ack.acknowledge();
    }
}
